SystemOrganization addCategory: #'Parasol-Core'!

TestResource subclass: #BPWebDriverManagerResource
	instanceVariableNames: 'drivers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPWebDriverManagerResource methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
driverWithCapabilities: desiredCapabilities on: url

	drivers at: desiredCapabilities ifPresent: [ :cachedDriver |
		drivers removeKey: desiredCapabilities.
		[ cachedDriver get: url asString ] on: BPUnknownServerException do: [ :ex |
			self quitDriver: cachedDriver.
			^ self driverWithCapabilities: desiredCapabilities on: url.
		].
		^ cachedDriver].
	^ ((BPRemoteWebDriver withCapabilities: desiredCapabilities)
		get: url asString;
		yourself).! !

!BPWebDriverManagerResource methodsFor: 'private' stamp: 'KrisGybels 6/29/2012 15:22'!
quitDriver: driver

	[ driver quit ] on: BPUnknownServerException do: [ :ex | ]! !

!BPWebDriverManagerResource methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
quitOrCacheDriver: driver withCapabilities: capabilities

	drivers at: capabilities ifPresent: [ :cachedDriver |
		^self quitDriver: driver.
	].
		[
			driver getWindowHandles size - 1 timesRepeat: [ driver close ].
			driver switchTo window: driver getWindowHandles anyOne.
			driver get: 'about:'. "<-- Reset the browser window to a blank page, might be executing scripts, timed refreshes or whatever in the background otherwise."
			driver getKeyboard sendKeys: (String with: BPKeys null). "<-- release any modifier keys."
		] on: BPUnknownServerException do: [ :ex | self quitDriver: driver. ^ self ].
		drivers at: capabilities put: driver.! !

!BPWebDriverManagerResource methodsFor: 'running' stamp: 'KrisGybels 4/17/2012 14:37'!
setUp

	super setUp.
	drivers := Dictionary new.! !

!BPWebDriverManagerResource methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:22'!
tearDown

	drivers do: [ :driver |
		[ driver quit ] on: BPUnsupportedCommandException do: [ :error | ].
	].
	super tearDown.
! !

TestCase subclass: #BPWebDriverTestCase
	instanceVariableNames: 'driver screenshotCounter'
	classVariableNames: 'DefaultDesiredCapabilities'
	poolDictionaries: ''
	category: 'Parasol-Core'!

BPWebDriverTestCase subclass: #BPSeasideWebDriverTestCase
	instanceVariableNames: 'testComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPSeasideWebDriverTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:54'!
baseURL

	^super baseURL , self registrationName , '/'! !

!BPSeasideWebDriverTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:54'!
componentClass

	self subclassResponsibility.! !

!BPSeasideWebDriverTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:54'!
componentUnderTest
	^ testComponent value! !

!BPSeasideWebDriverTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:54'!
componentUnderTest: anObject
	"Component needs to be held inside a wrapper for running tests in GS, otherwise commit conflicts happen during test execution when setting up the test component"
	testComponent value: anObject! !

!BPSeasideWebDriverTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:54'!
configureTestApp: testApp! !

!BPSeasideWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/20/2014 09:13'!
registrationName

	^ 'WDTest'! !

!BPSeasideWebDriverTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:54'!
setUp
	BPPlatform current ensureSeasideServerRunning.
	testComponent := BPValueHolder new.
	super setUp.! !

!BPSeasideWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/20/2014 09:13'!
startTestApp

	self configureTestApp: (WAAdmin
				register: (BPClassInstantiationNotificationWrapper
						withRealClass: self componentClass
						instantiationNotificationBlock: [:newInstance | self componentUnderTest: newInstance])
				asApplicationAt: self registrationName)! !

!BPSeasideWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/20/2014 09:13'!
stopTestApp

	WAAdmin unregister: self registrationName! !

!BPWebDriverTestCase class methodsFor: 'accessing' stamp: 'haerle 8/20/2014 09:13'!
defaultDesiredCapabilities

	^DefaultDesiredCapabilities
		ifNil: [DefaultDesiredCapabilities := BPDesiredCapabilities firefox]! !

!BPWebDriverTestCase class methodsFor: 'accessing' stamp: 'haerle 8/20/2014 09:13'!
defaultDesiredCapabilities: aBPDesiredCapabilities
	DefaultDesiredCapabilities := BPDesiredCapabilities! !

!BPWebDriverTestCase class methodsFor: 'accessing' stamp: 'KrisGybels 6/29/2012 15:13'!
resources

	^ super resources , (Array with: BPWebDriverManagerResource)! !

!BPWebDriverTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:53'!
baseURL

	^'http://localhost:' , BPPlatform current port printString , '/'! !

!BPWebDriverTestCase methodsFor: 'running' stamp: 'chaerle 8/20/2014 15:17'!
defaultTimeout
	"Default timeout in Squeak is 5 seconds. Use 60 instead. Other platforms don't seem to use, so this method could be an extension in the Squeak platform."
	^60! !

!BPWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:17'!
desiredDriverBrowserCapabilities

	^ BPDesiredCapabilities firefox! !

!BPWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:46'!
flag: x! !

!BPWebDriverTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:53'!
setUp

	super setUp.
	self startTestApp.
	driver := BPWebDriverManagerResource current
				driverWithCapabilities: self desiredDriverBrowserCapabilities
				on: self baseURL.
	screenshotCounter := 1! !

!BPWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/20/2014 09:13'!
startTestApp! !

!BPWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/20/2014 09:13'!
stopTestApp! !

!BPWebDriverTestCase methodsFor: 'misc.' stamp: 'haerle 8/19/2014 14:46'!
takeScreenshot

	BPPlatform current
		fileWrite: 'Screenshot-' , self class name , '-' , self selector , '-'
				, screenshotCounter asString , '.png'
		contents: driver getScreenshotAsByteArray.
	screenshotCounter := screenshotCounter + 1! !

!BPWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/20/2014 09:13'!
tearDown

	driver
		ifNotNil: 
			[BPWebDriverManagerResource current quitOrCacheDriver: driver
				withCapabilities: self desiredDriverBrowserCapabilities].
	self stopTestApp.
	super tearDown! !

Object subclass: #BPHttpResponse
	instanceVariableNames: 'httpStatus headers contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPHttpResponse methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
contents

	^contents! !

!BPHttpResponse methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
contents: anObject

	contents := anObject! !

!BPHttpResponse methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
headers

	^headers! !

!BPHttpResponse methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
headers: anObject

	headers := anObject! !

!BPHttpResponse methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
httpStatus

	^httpStatus! !

!BPHttpResponse methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
httpStatus: anObject

	httpStatus := anObject! !

Object subclass: #BPObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

BPObject subclass: #BPAction
	instanceVariableNames: 'driver arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPAction methodsFor: 'misc' stamp: 'JohanBrichau 5/10/2012 13:52'!
actionPathSegment 
	self subclassResponsibility ! !

!BPAction methodsFor: 'private' stamp: 'JohanBrichau 5/10/2012 14:03'!
argumentAt: aString put: aValue 
	arguments at: aString put: aValue! !

!BPAction methodsFor: 'initialize-release' stamp: 'JohanBrichau 5/10/2012 14:05'!
initWithDriver: initializationDriver
	driver := initializationDriver.
! !

!BPAction methodsFor: 'initialize-release' stamp: 'JohanBrichau 5/10/2012 14:06'!
initialize 
	super initialize.
	arguments := Dictionary new.! !

!BPAction methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
perform
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Action.html#perform()
	"

	^driver httpPostHandleResponse: (driver baseSessionURL
				, self actionPathSegment)
		jsonData: arguments! !

BPAction subclass: #BPButtonReleaseAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPButtonReleaseAction class methodsFor: 'instance creation' stamp: 'KrisGybels 4/12/2012 11:37'!
driver: driver

	^ self new initWithDriver: driver! !

!BPButtonReleaseAction methodsFor: 'perform' stamp: 'haerle 8/19/2014 14:46'!
perform

	driver
		httpPostHandleResponse: (driver baseSessionURL, 'buttonup')
		jsonData: Dictionary new! !

BPAction subclass: #BPClickAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPClickAction class methodsFor: 'instance creation' stamp: 'KrisGybels 4/6/2012 14:06'!
driver: driver buttonNumber: buttonNumber

	^ self new driver: driver buttonNumber: buttonNumber! !

!BPClickAction methodsFor: 'perform' stamp: 'JohanBrichau 5/10/2012 14:08'!
actionPathSegment 
	^ 'click'! !

!BPClickAction methodsFor: 'initialize-release' stamp: 'JohanBrichau 5/10/2012 14:07'!
driver: initializationDriver buttonNumber: initializationButtonNumber

	self initWithDriver: initializationDriver.
	arguments at: 'button' put: initializationButtonNumber.! !

BPAction subclass: #BPClickAndHoldAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPClickAndHoldAction class methodsFor: 'instance creation' stamp: 'KrisGybels 4/12/2012 11:37'!
driver: driver

	^ self new initWithDriver: driver! !

!BPClickAndHoldAction methodsFor: 'perform' stamp: 'JohanBrichau 5/10/2012 14:34'!
actionPathSegment 
	^ 'buttondown'! !

BPAction subclass: #BPCompositeAction
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPCompositeAction class methodsFor: 'instance creation' stamp: 'KrisGybels 4/6/2012 13:19'!
driver: driver

	^ self new initWithDriver: driver! !

!BPCompositeAction methodsFor: 'misc' stamp: 'KrisGybels 4/6/2012 13:15'!
addAction: action

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/CompositeAction.html#addAction(org.openqa.selenium.interactions.Action)
	"
	
	actions add: action.! !

!BPCompositeAction methodsFor: 'initialize-release' stamp: 'KrisGybels 4/6/2012 13:14'!
initialize

	super initialize.
	actions := OrderedCollection new.! !

!BPCompositeAction methodsFor: 'misc' stamp: 'KrisGybels 4/6/2012 13:16'!
perform

	actions do: [ :action |
		action perform.
	]! !

BPAction subclass: #BPDoubleClickAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPDoubleClickAction class methodsFor: 'instance creation' stamp: 'KrisGybels 4/6/2012 13:26'!
driver: driver

	^ self new initWithDriver: driver! !

!BPDoubleClickAction methodsFor: 'perform' stamp: 'JohanBrichau 5/10/2012 14:34'!
actionPathSegment 
	^ 'doubleclick'! !

BPAction subclass: #BPMoveMouseAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPMoveMouseAction class methodsFor: 'instance creation' stamp: 'KrisGybels 4/6/2012 13:23'!
driver: driver element: webElement

	^ self new initWithDriver: driver element: webElement! !

!BPMoveMouseAction class methodsFor: 'instance creation' stamp: 'JohanBrichau 3/3/2014 21:39'!
driver: driver offset: offset

	^ self new initWithDriver: driver offset: offset! !

!BPMoveMouseAction methodsFor: 'perform' stamp: 'JohanBrichau 5/10/2012 13:58'!
actionPathSegment 
	^ 'moveto'! !

!BPMoveMouseAction methodsFor: 'initialize-release' stamp: 'JohanBrichau 5/10/2012 14:10'!
initWithDriver: initializationDriver element: initializationWebElement

	self initWithDriver: initializationDriver.
	self argumentAt: 'element' put: initializationWebElement elementID.! !

!BPMoveMouseAction methodsFor: 'initialize-release' stamp: 'JohanBrichau 3/3/2014 21:39'!
initWithDriver: initializationDriver offset: offset

	self initWithDriver: initializationDriver.
	self xOffset: offset x yOffset: offset y! !

!BPMoveMouseAction methodsFor: 'accessing' stamp: 'JohanBrichau 5/10/2012 14:10'!
xOffset: x yOffset: y
	self argumentAt: 'xoffset' put: x.
	self argumentAt: 'yoffset' put: y.! !

BPObject subclass: #BPActions
	instanceVariableNames: 'driver action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPActions class methodsFor: 'instance creation' stamp: 'KrisGybels 4/6/2012 13:07'!
driver: driver

	^ self new initWithDriver: driver! !

!BPActions methodsFor: 'misc' stamp: 'KrisGybels 6/29/2012 15:14'!
build

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#build()
	"
	
	^ [ action ] ensure: [ action := BPCompositeAction driver: driver ]! !

!BPActions methodsFor: 'misc' stamp: 'KrisGybels 6/29/2012 15:14'!
clickAndHold

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#clickAndHold()
	"
	
	action addAction: (BPClickAndHoldAction driver: driver)
	! !

!BPActions methodsFor: 'misc' stamp: 'JohanBrichau 3/3/2014 20:16'!
clickAndHold: webElement

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#clickAndHold(org.openqa.selenium.WebElement)
	"
	
	self
		moveToElement: webElement;
		clickAndHold.! !

!BPActions methodsFor: 'misc' stamp: 'KrisGybels 6/29/2012 15:14'!
contextClick: webElement

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#contextClick(org.openqa.selenium.WebElement)
	"
	
	self moveToElement: webElement.
	action addAction: (BPClickAction driver: driver buttonNumber: 2).! !

!BPActions methodsFor: 'misc' stamp: 'KrisGybels 6/29/2012 15:15'!
doubleClick

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#doubleClick()
	"
	
	action addAction: (BPDoubleClickAction driver: driver)
	! !

!BPActions methodsFor: 'misc' stamp: 'KrisGybels 4/6/2012 13:27'!
doubleClick: webElement

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#doubleClick()
	"
	
	self
		moveToElement: webElement;
		doubleClick.
! !

!BPActions methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 11:33'!
drag: sourceWebElement andDrop: targetWebElement

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#dragAndDrop(org.openqa.selenium.WebElement,%20org.openqa.selenium.WebElement)	
	"
	
	self
		clickAndHold: sourceWebElement;
		releaseButton: targetWebElement.! !

!BPActions methodsFor: 'misc' stamp: 'JohanBrichau 5/28/2013 15:08'!
drag: sourceWebElement andDropBy: aPoint

	"
http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#dragAndDropBy(org.openqa.selenium.WebElement,%20int,%20int)
	"
	
	self
		moveToElement: sourceWebElement offset: (1@1);
		clickAndHold;
		moveToElement: sourceWebElement offset: aPoint;
		releaseButton.! !

!BPActions methodsFor: 'initialize-release' stamp: 'haerle 8/19/2014 14:46'!
initWithDriver: initializationDriver

	self initialize.
	driver := initializationDriver.
	action := BPCompositeAction driver: driver.! !

!BPActions methodsFor: 'misc' stamp: 'JohanBrichau 3/3/2014 21:38'!
moveByOffset: offset

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#moveByOffset(int, int)
	"
	
	action addAction: (BPMoveMouseAction driver: driver offset: offset)
	! !

!BPActions methodsFor: 'misc' stamp: 'JohanBrichau 3/3/2014 21:38'!
moveToElement: webElement

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#moveToElement(org.openqa.selenium.WebElement)
	"
	
	action addAction: (BPMoveMouseAction driver: driver element: webElement)
	! !

!BPActions methodsFor: 'misc' stamp: 'JohanBrichau 3/3/2014 21:38'!
moveToElement: webElement offset: aPoint

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#moveToElement(org.openqa.selenium.WebElement,%20int,%20int)
	"
	
	action addAction: ((BPMoveMouseAction driver: driver element: webElement) xOffset: aPoint x yOffset: aPoint y; yourself)
	! !

!BPActions methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 12:06'!
perform

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#perform()
	"

	self build perform
! !

!BPActions methodsFor: 'misc' stamp: 'KrisGybels 6/29/2012 15:14'!
releaseButton

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#release()
	"
	
	action addAction: (BPButtonReleaseAction driver: driver)
! !

!BPActions methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 11:32'!
releaseButton: webElement

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/interactions/Actions.html#release(org.openqa.selenium.WebElement)
	"
	
	self
		moveToElement: webElement;
		releaseButton.! !

BPObject subclass: #BPCapabilities
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPCapabilities methodsFor: 'comparing' stamp: 'KrisGybels 10/9/2015 10:10'!
= other

	^ (self class = other class) and: [
		self asDictionary = other asDictionary.
	].! !

!BPCapabilities methodsFor: 'converting' stamp: 'KrisGybels 10/9/2015 10:09'!
asDictionary

	^ dict! !

!BPCapabilities methodsFor: 'misc' stamp: 'KrisGybels 10/9/2015 10:18'!
getBrowserName

	"http://seleniumhq.github.io/selenium/docs/api/java/org/openqa/selenium/Capabilities.html#getBrowserName--"
	
	^ self getCapability: 'browserName'
! !

!BPCapabilities methodsFor: 'misc' stamp: 'KrisGybels 10/9/2015 10:10'!
getCapability: capabilityName

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/DesiredCapabilities.html#getCapability(java.lang.String)
	"
	
	^ dict at: capabilityName! !

!BPCapabilities methodsFor: 'comparing' stamp: 'KrisGybels 10/9/2015 10:10'!
hash

	^ self asDictionary hash! !

!BPCapabilities methodsFor: 'initialize-release' stamp: 'KrisGybels 10/9/2015 10:08'!
initialize

	super initialize.
	dict := Dictionary new.! !

BPCapabilities subclass: #BPDesiredCapabilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPDesiredCapabilities class methodsFor: 'predefined' stamp: 'KrisGybels 4/10/2012 09:09'!
chrome

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/DesiredCapabilities.html#chrome()
	"

	^ self new
		setCapability: 'browserName' to: 'chrome';
		yourself
	! !

!BPDesiredCapabilities class methodsFor: 'predefined' stamp: 'KrisGybels 4/10/2012 09:16'!
firefox

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/DesiredCapabilities.html#firefox()
	"

	^ self new
		setCapability: 'browserName' to: 'firefox';
		yourself
	! !

!BPDesiredCapabilities class methodsFor: 'predefined' stamp: 'KrisGybels 4/13/2012 08:08'!
htmlUnit

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/DesiredCapabilities.html#htmlUnit()
	"

	^ self new
		setCapability: 'browserName' to: 'htmlunit';
		yourself
! !

!BPDesiredCapabilities class methodsFor: 'predefined' stamp: 'KrisGybels 10/25/2013 10:18'!
safari

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/DesiredCapabilities.html#safari()
	"

	^ self new
		setCapability: 'browserName' to: 'safari';
		yourself
	! !

!BPDesiredCapabilities methodsFor: 'misc' stamp: 'KrisGybels 4/10/2012 09:05'!
setCapability: capabilityName to: capabilityValue

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/DesiredCapabilities.html#setCapability(java.lang.String,%20java.lang.String)
	"
	
	dict at: capabilityName put: capabilityValue! !

BPObject subclass: #BPClassInstantiationNotificationWrapper
	instanceVariableNames: 'realClass instantiationNotificationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPClassInstantiationNotificationWrapper class methodsFor: 'instance creation' stamp: 'KrisGybels 4/12/2012 21:51'!
withRealClass: realClass instantiationNotificationBlock: instantiationNotificationBlock

	^ self basicNew initWithRealClass: realClass instantiationNotificationBlock: instantiationNotificationBlock! !

!BPClassInstantiationNotificationWrapper methodsFor: 'initialize-release' stamp: 'KrisGybels 4/12/2012 21:53'!
initWithRealClass: initializationRealClass instantiationNotificationBlock: initializationInstantiationNotificationBlock

	self initialize.
	realClass := initializationRealClass.
	instantiationNotificationBlock := initializationInstantiationNotificationBlock.! !

!BPClassInstantiationNotificationWrapper methodsFor: 'instance creation' stamp: 'KrisGybels 4/12/2012 21:56'!
new

	| newInstance |
	newInstance := realClass new.
	instantiationNotificationBlock value: newInstance.
	^ newInstance! !

BPObject subclass: #BPKeyboard
	instanceVariableNames: 'driver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPKeyboard class methodsFor: 'instance creation' stamp: 'KrisGybels 4/10/2012 17:06'!
withDriver: driver

	^ self basicNew initWithDriver: driver! !

!BPKeyboard methodsFor: 'initialize-release' stamp: 'haerle 8/19/2014 14:46'!
initWithDriver: initializationDriver

	self initialize.
	driver := initializationDriver.! !

!BPKeyboard methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
sendKeys: keyString
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keyboard.html#sendKeys(java.lang.CharSequence...)
	"

	| keyArray |
	keyArray := keyString asArray collect: [:char | String with: char].
	driver httpPostHandleResponse: driver baseSessionURL , 'keys'
		jsonData: ((Dictionary new)
				at: 'value' put: keyArray;
				yourself)! !

BPObject subclass: #BPKeys
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:18'!
add

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#ADD
	"
	
	^ Character codePoint: 16rE025
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:25'!
alt

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#ALT
	"
	
	^ Character codePoint: 16rE00A! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:30'!
arrowDown

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#ARROW_DOWN
	"
	
	^ self down
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:28'!
arrowLeft

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#ARROW_LEFT
	"
	
	^ self left! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:30'!
arrowRight

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#ARROW_RIGHT
	"
	
	^ self right
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:29'!
arrowUp

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#ARROW_UP
	"
	
	^ self up! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:23'!
backSpace

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#BACK_SPACE
	"
	
	^ Character codePoint: 16rE003
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:22'!
cancel

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#CANCEL
	"
	
	^ Character codePoint: 16rE001
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:23'!
clear

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#CLEAR
	"
	
	^ Character codePoint: 16rE005
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/17/2012 11:24'!
command

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#COMMAND
	"
	
	^ Character codePoint: 16rE03D
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:25'!
control

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#CONTROL
	"
	
	^ Character codePoint: 16rE009
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:19'!
decimal

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#DECIMAL
	"
	
	^ Character codePoint: 16rE028
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:31'!
delete

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#DELETE
	"
	
	^ Character codePoint: 16rE017
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:19'!
divide

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#DIVIDE
	"
	
	^ Character codePoint: 16rE029
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:30'!
down

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#DOWN
	"
	
	^ Character codePoint: 16rE015
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:27'!
end

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#END
	"
	
	^ Character codePoint: 16rE010
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:23'!
enter

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#ENTER
	"
	
	^ Character codePoint: 16rE007
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:32'!
equals

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#EQUALS
	"
	
	^ Character codePoint: 16rE019! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:26'!
escape

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#ESCAPE
	"
	
	^ Character codePoint: 16rE00C
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:19'!
f1

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F1
	"
	
	^ Character codePoint: 16rE031
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:20'!
f10

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F10
	"
	
	^ Character codePoint: 16rE03A
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:21'!
f11

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F11
	"
	
	^ Character codePoint: 16rE03B
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:21'!
f12

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F12
	"
	
	^ Character codePoint: 16rE03C
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:20'!
f2

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F2
	"
	
	^ Character codePoint: 16rE032
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:20'!
f3

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F3
	"
	
	^ Character codePoint: 16rE033
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:20'!
f4

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F4
	"
	
	^ Character codePoint: 16rE034
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:20'!
f5

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F5
	"
	
	^ Character codePoint: 16rE035
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:20'!
f6

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F6
	"
	
	^ Character codePoint: 16rE036
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:20'!
f7

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F7
	"
	
	^ Character codePoint: 16rE037
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:20'!
f8

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F8
	"
	
	^ Character codePoint: 16rE038
! !

!BPKeys class methodsFor: 'function keys' stamp: 'KrisGybels 4/18/2012 10:20'!
f9

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#F9
	"
	
	^ Character codePoint: 16rE039
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:22'!
help

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#HELP
	"
	
	^ Character codePoint: 16rE002
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:27'!
home

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#HOME
	"
	
	^ Character codePoint: 16rE011
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:31'!
insert

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#INSERT
	"
	
	^ Character codePoint: 16rE016
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:28'!
left

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#LEFT
	"
	
	^ Character codePoint: 16rE012
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:25'!
leftAlt

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#LEFT_ALT
	"
	
	^ self alt! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:25'!
leftControl

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#LEFT_CONTROL
	"
	
	^ self control
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:24'!
leftShift

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#LEFT_SHIFT
	"
	
	^ self shift
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:17'!
multiply

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#MULTIPLY
	"
	
	^ Character codePoint: 16rE024
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/17/2012 11:23'!
null

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NULL
	"
	
	^ Character codePoint: 16rE000
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:16'!
numpad0

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD0
	"

	^ Character codePoint: 16rE01A
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:16'!
numpad1

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD1
	"

	^ Character codePoint: 16rE01B
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:16'!
numpad2

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD2
	"

	^ Character codePoint: 16rE01C
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:16'!
numpad3

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD3
	"

	^ Character codePoint: 16rE01D
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:16'!
numpad4

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD4
	"

	^ Character codePoint: 16rE01E
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:16'!
numpad5

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD5
	"

	^ Character codePoint: 16rE01F
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:16'!
numpad6

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD6
	"

	^ Character codePoint: 16rE020
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:17'!
numpad7

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD7
	"

	^ Character codePoint: 16rE021
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:17'!
numpad8

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD8
	"

	^ Character codePoint: 16rE022
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:17'!
numpad9

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#NUMPAD9
	"

	^ Character codePoint: 16rE023
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/12/2012 12:20'!
pageDown

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#PAGE_DOWN
	"
	
	^ Character codePoint: 16rE00F
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:27'!
pageUp

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#PAGE_UP
	"
	
	^ Character codePoint: 16rE00E
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:26'!
pause

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#PAUSE
	"
	
	^ Character codePoint: 16rE00B
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/15/2012 16:29'!
return

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#RETURN
	"
	
	^ Character codePoint: 16rE006
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 2/6/2013 13:31'!
right

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#RIGHT
	"
	
	^ Character codePoint: 16rE014
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:31'!
semicolon

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#SEMICOLON
	"
	
	^ Character codePoint: 16rE018! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:18'!
separator

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#SEPARATOR
	"
	
	^ Character codePoint: 16rE026
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:24'!
shift

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#SHIFT
	"
	
	^ Character codePoint: 16rE008
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:26'!
space

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#SPACE
	"
	
	^ Character codePoint: 16rE00D
! !

!BPKeys class methodsFor: 'number pad keys' stamp: 'KrisGybels 4/18/2012 10:18'!
subtract

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#SUBTRACT
	"
	
	^ Character codePoint: 16rE027
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:23'!
tab

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#TAB
	"
	
	^ Character codePoint: 16rE004
! !

!BPKeys class methodsFor: 'misc. keys' stamp: 'KrisGybels 4/18/2012 10:28'!
up

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/Keys.html#UP
	"
	
	^ Character codePoint: 16rE013
! !

!BPObject class methodsFor: 'instance creation' stamp: 'StephanEggermont 9/28/2012 16:49'!
new
	^ self basicNew initialize! !

!BPObject methodsFor: 'initialize-release' stamp: 'haerle 8/19/2014 14:46'!
flag: x! !

!BPObject methodsFor: 'initialize-release' stamp: 'StephanEggermont 9/28/2012 16:47'!
initialize
! !

BPObject subclass: #BPOptions
	instanceVariableNames: 'driver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPOptions class methodsFor: 'instance creation' stamp: 'KrisGybels 11/6/2012 10:21'!
withDriver: driver

	^ self new initWithDriver: driver! !

!BPOptions methodsFor: 'initialize-release' stamp: 'KrisGybels 11/6/2012 10:22'!
initWithDriver: initialDriver

	self initialize.
	driver := initialDriver.! !

!BPOptions methodsFor: 'misc' stamp: 'KrisGybels 9/8/2013 20:22'!
timeouts

	"
		http://selenium.googlecode.com/git/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.RemoteWebDriverOptions.html#timeouts()
	"
	
	^ BPTimeouts withDriver: driver! !

!BPOptions methodsFor: 'misc' stamp: 'KrisGybels 11/6/2012 10:30'!
window

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.Options.html#window()
	"
	
	self flag: 'It is not clear in the Java documentation what is meant by the current window, current at the time of calling this method, or current at the time you are interacting with the window object? Note that in the wire protocol POST requests on /session/:sessionId/window/:windowHandle/size are allowed to use "current" for the windowHandle parameter'.
	^ BPWindow withDriver: driver handle: driver getWindowHandle! !

BPObject subclass: #BPPlatform
	instanceVariableNames: 'port'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPPlatform class methodsFor: 'facade' stamp: 'KrisGybels 8/26/2014 19:58'!
current
	^ Current ifNil: [ self error: 'No current BPPlatform is set, send #initialize to the appropriate subclass first.' ]! !

!BPPlatform class methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:13'!
current: aPlatform
	Current := aPlatform! !

!BPPlatform class methodsFor: 'class initialization' stamp: 'haerle 8/20/2014 09:13'!
initialize
	self ~~ BPPlatform ifTrue: [BPPlatform current: self new]! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
byteArrayFromBase64String: aString
	self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'KrisGybels 8/26/2014 20:23'!
ensureSeasideServerRunning

	"By default do nothing, subclasses can override this if necessary."
! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
fileDelete: fileName

	self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
fileWrite: fileName contents: aStringOrByteArray

	self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
httpClient

	^self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
httpDelete: url

	self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
httpGet: aString
	self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
httpPost: url data: aString timeout: anInteger
	self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:13'!
isMacOSX

	^self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
jsonRead: aString
	self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
jsonWrite: aDictionary
	self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:13'!
pngImageFromByteArray: aByteArray

	self subclassResponsibility! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
port
	^port! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
port: aPort
	port:= aPort! !

!BPPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:46'!
signalException: exception
	"ANSI behaviour. Some dialects like VisualWork have non-standard behaviour, which can be overwritten in subclasses."

	^exception signal! !

BPObject subclass: #BPRemoteWebDriver
	instanceVariableNames: 'sessionID exceptions'
	classVariableNames: 'ServerHost ServerPort'
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPRemoteWebDriver commentStamp: 'haerle 8/19/2014 14:46' prior: 0!
An XXRemoteWebDriver represents the client-side object-oriented interface to a single session on a RemoteWebDriverServer [1]. It presents an interface similar to that of its Java counterpart [2,3]. It communicates with the RemoteWebDriverServer through the WebDriver wire protocol [4].

	[1]: http://code.google.com/p/selenium/wiki/RemoteWebDriverServer
	[2]: http://selenium.googlecode.com/svn/trunk/docs/api/java/index.html
	[3]: http://code.google.com/p/selenium/source/browse/trunk/java/client/src/org/openqa/selenium/remote/RemoteWebDriver.java
	[4]: http://code.google.com/p/selenium/wiki/JsonWireProtocol
!

!BPRemoteWebDriver class methodsFor: 'instance creation' stamp: 'KrisGybels 6/29/2012 15:17'!
new

	^ self withCapabilities: BPDesiredCapabilities firefox! !

!BPRemoteWebDriver class methodsFor: 'configuration' stamp: 'KrisGybels 8/26/2014 21:20'!
serverHost

	^ ServerHost ifNil: [ '127.0.0.1' ]! !

!BPRemoteWebDriver class methodsFor: 'configuration' stamp: 'KrisGybels 8/26/2014 21:20'!
serverHost: hostName

	ServerHost := hostName! !

!BPRemoteWebDriver class methodsFor: 'configuration' stamp: 'KrisGybels 8/26/2014 21:21'!
serverPort

	^ ServerPort ifNil: [ 4444 ]! !

!BPRemoteWebDriver class methodsFor: 'configuration' stamp: 'KrisGybels 8/26/2014 21:21'!
serverPort: portNumber

	ServerPort := portNumber! !

!BPRemoteWebDriver class methodsFor: 'instance creation' stamp: 'KrisGybels 4/10/2012 09:27'!
withCapabilities: capabilities

	^ self basicNew initWithCapabilities: capabilities! !

!BPRemoteWebDriver methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
baseDriverURL

	^'http://' , self class serverHost , ':'
		, self class serverPort printString , '/wd/hub/'! !

!BPRemoteWebDriver methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
baseSessionURL

	^self baseDriverURL , 'session/' , sessionID, '/'! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
close

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.html#close()
	"

	self handleResponse: (self httpDelete: (self baseSessionURL , 'window'))! !

!BPRemoteWebDriver methodsFor: 'private-response-handling' stamp: 'haerle 8/19/2014 14:46'!
exceptions

	^exceptions
		ifNil: 
			[exceptions := Dictionary new.
			exceptions
				at: 7 put: BPNoSuchElementException;
				at: 10 put: BPStaleElementReferenceException;
				at: 11 put: BPElementNotVisibleException;
				at: 13 put: BPUnknownServerException;
				at: 32 put: BPInvalidSelectorException.
			exceptions]! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
executeScript: scriptString with: arguments
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#executeScript(java.lang.String,%20java.lang.Object...)
	"

	self
		flag: 'Check whether this implementation matches the description of the original Java method'.
	self
		flag: 'One point definitely missing is that this does not yet handle converting an {ELEMENT: ....} thingy back to a WebElement.'.
	^self handleResponse: (self
				httpPost: (self baseSessionURL , 'execute')
				jsonData: (Dictionary new
						at: 'script' put: scriptString;
						at: 'args' put: arguments;
						yourself))
		onSuccess: [:result | result at: 'value']! !

!BPRemoteWebDriver methodsFor: 'private' stamp: 'haerle 8/19/2014 14:46'!
findElementBy: selectorString with: valueString

	^self handleResponse: (self
				httpPost: (self baseSessionURL , 'element')
				jsonData: (Dictionary new
						at: 'using' put: selectorString;
						at: 'value' put: valueString;
						yourself))
		onSuccess: 
			[:result |
			BPWebElement driver: self elementID: ((result at: 'value') at: 'ELEMENT')]! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 19:29'!
findElementByCSSSelector: cssSelectorString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementByCssSelector(java.lang.String)
	"
	
	^ self findElementBy: 'css selector' with: cssSelectorString

	
! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'JohanBrichau 5/18/2012 17:03'!
findElementByClassName: nameString

	"
http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementByClassName(java.lang.String)
	"
	
	^ self findElementBy: 'class name' with: nameString! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 19:28'!
findElementByID: idString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementById(java.lang.String)
	"
	
	^ self findElementBy: 'id' with: idString! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 20:19'!
findElementByLinkText: textString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementByLinkText(java.lang.String)
	"

	^ self findElementBy: 'link text' with: textString
! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 19:28'!
findElementByName: nameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementByName(java.lang.String)
	"

	^ self findElementBy: 'name' with: nameString

! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 20:20'!
findElementByPartialLinkText: textString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementByPartialLinkText(java.lang.String)
	"

	^ self findElementBy: 'partial link text' with: textString
! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 19:49'!
findElementByTagName: tagNameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementByTagName(java.lang.String)
	"

	^ self findElementBy: 'tag name' with: tagNameString
! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 4/12/2012 19:55'!
findElementByXPath: xpathString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementByXPath(java.lang.String)
	"

	^ self findElementBy: 'xpath' with: xpathString
! !

!BPRemoteWebDriver methodsFor: 'private' stamp: 'haerle 8/19/2014 14:46'!
findElementsBy: selectorString with: valueString

	^self handleResponse: (self
				httpPost: (self baseSessionURL , 'elements')
				jsonData: (Dictionary new
						at: 'using' put: selectorString;
						at: 'value' put: valueString;
						yourself))
		onSuccess: 
			[:result |
			(result at: 'value')
				collect: [:e | BPWebElement driver: self elementID: (e at: 'ELEMENT')]]! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'JohanBrichau 5/18/2012 17:00'!
findElementsByCSSSelector: cssSelectorString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementsByCssSelector(java.lang.String)
	"
	
	^ self findElementsBy: 'css selector' with: cssSelectorString

	
! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'JohanBrichau 5/18/2012 17:03'!
findElementsByClassName: nameString

	"
http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementsByClassName(java.lang.String)
	"
	
	^ self findElementsBy: 'class name' with: nameString! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'AndyKellens 2/13/2013 15:55'!
findElementsByPartialLinkText: nameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElements(org.openqa.selenium.By)
	"
	
	^ self findElementsBy: 'partial link text' with: nameString
! !

!BPRemoteWebDriver methodsFor: 'private' stamp: 'ThomasCleenewerck 7/6/2012 17:48'!
findElementsByTagName: tagNameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementsByTagName(java.lang.String)
	"

	^ self findElementsBy: 'tag name' with: tagNameString
! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'StephanEggermont 10/1/2012 19:40'!
findElementsByXPath: tagNameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#findElementsByXPath(java.lang.String)
	"

	^ self findElementsBy: 'xpath' with: tagNameString! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
get: urlString
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.html#get(java.lang.String)
	"

	self httpPostHandleResponse: (self baseSessionURL , 'url')
		jsonData: (Dictionary new
				at: 'url' put: urlString;
				yourself)! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 6/29/2012 15:19'!
getKeyboard

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.html#getKeyboard()
	"
	
	^ BPKeyboard withDriver: self! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getPageSource
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.html#getPageSource()
	"

	^self httpGetHandleResponse: self baseSessionURL , 'source'
		onSuccess: [:result | result at: 'value']! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getScreenshotAsByteArray
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/TakesScreenshot.html#getScreenshotAs(org.openqa.selenium.OutputType)
	"

	^self httpGetHandleResponse: self baseSessionURL , 'screenshot'
		onSuccess: 
			[:result |
			BPPlatform current byteArrayFromBase64String: (result at: 'value')]! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getTitle
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.html#getTitle()
	"

	^self httpGetHandleResponse: self baseSessionURL , 'title'
		onSuccess: [:result | result at: 'value']! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getWindowHandle
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.html#getWindowHandle()
	"

	^self httpGetHandleResponse: self baseSessionURL , 'window_handle'
		onSuccess: [:result | result at: 'value']! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getWindowHandles
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.html#getWindowHandles()
	"

	^self httpGetHandleResponse: self baseSessionURL , 'window_handles'
		onSuccess: [:result | result at: 'value']! !

!BPRemoteWebDriver methodsFor: 'private' stamp: 'KrisGybels 8/26/2014 19:28'!
handleResponse: response

	(response httpStatus ~= 204) ifTrue: [
		self handleResponse: response onSuccess: [ :result | (result at: 'value') ifNotNil: [ self error: 'Value unexpectedly not JSON null' ] ].
	]
! !

!BPRemoteWebDriver methodsFor: 'private-response-handling' stamp: 'KrisGybels 8/26/2014 19:19'!
handleResponse: response onSuccess: successBlock

	| result status message exceptionClass httpStatus |
	httpStatus := response httpStatus.
	httpStatus = 404 ifTrue: [BPUnsupportedCommandException signal].
	httpStatus = 204 ifTrue: [ self error: 'Unexpected response without entity' ].
	result := BPPlatform current jsonRead: response contents.
	status := result at: 'status'.
	status = 0 ifTrue: [^successBlock value: result].
	message := (result at: 'value') at: 'message'.
	exceptionClass := self exceptions at: status ifAbsent: [BPException].
	BPPlatform current signalException: ((exceptionClass new)
				errorCode: status;
				messageText: message;
				yourself)! !

!BPRemoteWebDriver methodsFor: 'private-http' stamp: 'topa 4/3/2013 16:40'!
httpDelete: url

	^ BPPlatform current  httpDelete: url! !

!BPRemoteWebDriver methodsFor: 'private-http' stamp: 'topa 4/3/2013 16:40'!
httpGet: url

	^ BPPlatform current httpGet: url! !

!BPRemoteWebDriver methodsFor: 'private-http' stamp: 'haerle 8/19/2014 14:46'!
httpGetHandleResponse: url onSuccess: aBlock

	^self handleResponse: (BPPlatform current httpGet: url) onSuccess: aBlock! !

!BPRemoteWebDriver methodsFor: 'private-http' stamp: 'haerle 8/19/2014 14:46'!
httpPost: url jsonData: data

	^BPPlatform current
		httpPost: url
		data: (BPPlatform current jsonWrite: data)
		timeout: nil! !

!BPRemoteWebDriver methodsFor: 'private-http' stamp: 'haerle 8/19/2014 14:46'!
httpPost: url jsonData: data timeout: timeout

	^BPPlatform current
		httpPost: url
		data: (BPPlatform current jsonWrite: data)
		timeout: timeout! !

!BPRemoteWebDriver methodsFor: 'private-http' stamp: 'haerle 8/19/2014 14:46'!
httpPostHandleResponse: url jsonData: data

	^self handleResponse: (BPPlatform current
				httpPost: url
				data: (BPPlatform current jsonWrite: data)
				timeout: nil)! !

!BPRemoteWebDriver methodsFor: 'initialize-release' stamp: 'haerle 8/19/2014 14:46'!
initWithCapabilities: capabilities

	| response |
	self initialize.
	response := self
				httpPost: self baseDriverURL , 'session'
				jsonData: ((Dictionary new)
						at: 'desiredCapabilities' put: capabilities asDictionary;
						yourself)
				timeout: 30.
	sessionID := self sessionIdFromResponse: response! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 11/6/2012 10:25'!
manage

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.html#manage()
	"
	
	^ BPOptions withDriver: self! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 7/4/2012 10:46'!
quit

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.html#quit()
	"

	self handleResponse: (self httpDelete: self baseSessionURL)
! !

!BPRemoteWebDriver methodsFor: 'initialize-release' stamp: 'haerle 8/19/2014 14:46'!
sessionIdFromResponse: response

	(#(302 303) includes: response httpStatus)
		ifTrue: 
			[(((response headers at: 'location') reversed readStream)
				peekFor: $/;
				upTo: $/) reversed].
	response httpStatus = 200
		ifTrue: [^(BPPlatform current jsonRead: response contents) at: 'sessionId'].
	self
		error: 'Unexpected response status code ' , response httpStatus printString
				, ' while creating web driver session.'! !

!BPRemoteWebDriver methodsFor: 'misc' stamp: 'KrisGybels 6/29/2012 15:21'!
switchTo

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.html#switchTo()
	"
	
	^ BPTargetLocator withDriver: self! !

BPObject subclass: #BPSelect
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPSelect class methodsFor: 'instance creation' stamp: 'KrisGybels 5/30/2012 15:56'!
on: element

	^ self basicNew initWithElement: element! !

!BPSelect methodsFor: 'initialize-release' stamp: 'KrisGybels 5/30/2012 16:20'!
initWithElement: initializationElement

	self flag: 'This is supposed throw an exception if the element''s tag is not SELECT, http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/support/ui/Select.html#Select(org.openqa.selenium.WebElement)'.
	
	self initialize.
	element := initializationElement.! !

!BPSelect methodsFor: 'misc.' stamp: 'KrisGybels 5/30/2012 16:07'!
selectByValue: valueString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/support/ui/Select.html#selectByValue(java.lang.String)
	"

	| options |
	
	self flag: 'This implementation is not complete, check the Java version'.
	
	options := (element findElementsByXPath: './/option[@value=''' , valueString , ''']').
	options do: [ :option |
		option click.
	].! !

!BPSelect methodsFor: 'misc.' stamp: 'KrisGybels 10/9/2012 11:01'!
selectByVisibleText: visibleText

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/support/ui/Select.html#selectByVisibleText(java.lang.String)
	"

	| options |
	
	self flag: 'This implementation is not complete, check the Java version'.
	
	options := (element findElementsByXPath: './/option[normalize-space(.)=''' , visibleText , ''']').
	options do: [ :option |
		option click.
	].! !

BPObject subclass: #BPTargetLocator
	instanceVariableNames: 'driver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPTargetLocator class methodsFor: 'instance creation' stamp: 'KrisGybels 5/23/2012 16:35'!
withDriver: driver

	^ self basicNew initWithDriver: driver! !

!BPTargetLocator methodsFor: 'initialize-release' stamp: 'haerle 8/19/2014 14:46'!
initWithDriver: initializationDriver

	self initialize.
	driver := initializationDriver.! !

!BPTargetLocator methodsFor: 'misc.' stamp: 'haerle 8/19/2014 14:46'!
window: windowHandle
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.TargetLocator.html#window(java.lang.String)
	"

	driver httpPostHandleResponse: driver baseSessionURL , 'window'
		jsonData: ((Dictionary new)
				at: 'name' put: windowHandle;
				yourself)! !

BPObject subclass: #BPTimeouts
	instanceVariableNames: 'driver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPTimeouts class methodsFor: 'instance creation' stamp: 'KrisGybels 9/8/2013 20:13'!
withDriver: driver

	^ self new initWithDriver: driver! !

!BPTimeouts methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
implicitlyWait: duration
	"
		http://selenium.googlecode.com/git/docs/api/java/org/openqa/selenium/remote/RemoteWebDriver.RemoteWebDriverOptions.RemoteTimeouts.html#implicitlyWait(long,%20java.util.concurrent.TimeUnit)
	"

	driver
		httpPostHandleResponse: driver baseSessionURL , 'timeouts/implicit_wait'
		jsonData: ((Dictionary new)
				at: 'ms' put: duration asMilliseconds;
				yourself)! !

!BPTimeouts methodsFor: 'initialize-release' stamp: 'KrisGybels 9/8/2013 20:13'!
initWithDriver: initDriver

	driver := initDriver.! !

BPObject subclass: #BPWebElement
	instanceVariableNames: 'driver elementID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPWebElement class methodsFor: 'instance creation' stamp: 'KrisGybels 4/6/2012 12:31'!
driver: driver elementID: elementID

	^ self new initWithDriver: driver elementID: elementID! !

!BPWebElement methodsFor: 'comparing' stamp: 'haerle 8/19/2014 14:46'!
= other

	^(other isKindOf: self class) and: 
			[driver
				httpGetHandleResponse: (self baseElementURL , 'equals/') , other elementID
				onSuccess: [:result | result at: 'value']]! !

!BPWebElement methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
baseElementURL

	^driver baseSessionURL , 'element/' , elementID , '/'! !

!BPWebElement methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
clear
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#clear()
	"

	driver
		httpPostHandleResponse: (self baseElementURL , 'clear')
		jsonData: Dictionary new! !

!BPWebElement methodsFor: 'events' stamp: 'haerle 8/19/2014 14:46'!
click
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#click()
	"

	driver
		httpPostHandleResponse: (self baseElementURL , 'click')
		jsonData: Dictionary new! !

!BPWebElement methodsFor: 'accessing' stamp: 'KrisGybels 4/6/2012 13:29'!
elementID

	^ elementID! !

!BPWebElement methodsFor: 'private' stamp: 'haerle 8/19/2014 14:46'!
findElementBy: selectorString with: valueString

	^driver handleResponse: (driver
				httpPost: (self baseElementURL , 'element')
				jsonData: (Dictionary new
						at: 'using' put: selectorString;
						at: 'value' put: valueString;
						yourself))
		onSuccess: 
			[:result |
			self class driver: driver elementID: ((result at: 'value') at: 'ELEMENT')]! !

!BPWebElement methodsFor: 'misc' stamp: 'ThomasCleenewerck 7/6/2012 17:48'!
findElementByCSSSelector: cssSelectorString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElements(org.openqa.selenium.By)
	"
	
	^ self findElementBy: 'css selector' with: cssSelectorString! !

!BPWebElement methodsFor: 'misc' stamp: 'KrisGybels 4/15/2012 16:08'!
findElementByClassName: nameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElement(org.openqa.selenium.By)
	"
	
	^ self findElementBy: 'class name' with: nameString
! !

!BPWebElement methodsFor: 'misc' stamp: 'JohanBrichau 8/14/2012 19:57'!
findElementByPartialLinkText: nameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElement(org.openqa.selenium.By)
	"
	
	^ self findElementBy: 'partial link text' with: nameString
! !

!BPWebElement methodsFor: 'misc' stamp: 'KrisGybels 4/15/2012 16:18'!
findElementByTagName: nameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElement(org.openqa.selenium.By)
	"
	
	^ self findElementBy: 'tag name' with: nameString
! !

!BPWebElement methodsFor: 'misc' stamp: 'KrisGybels 10/9/2012 11:18'!
findElementByXPath: xpathString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElement(org.openqa.selenium.By)
	"
	
	^ self findElementBy: 'xpath' with: xpathString
! !

!BPWebElement methodsFor: 'private' stamp: 'haerle 8/19/2014 14:46'!
findElementsBy: selectorString with: valueString

	^driver handleResponse: (driver
				httpPost: (self baseElementURL , 'elements')
				jsonData: (Dictionary new
						at: 'using' put: selectorString;
						at: 'value' put: valueString;
						yourself))
		onSuccess: 
			[:result |
			(result at: 'value')
				collect: [:e | self class driver: driver elementID: (e at: 'ELEMENT')]]! !

!BPWebElement methodsFor: 'misc' stamp: 'JohanBrichau 5/23/2012 16:31'!
findElementsByCSSSelector: cssSelectorString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElements(org.openqa.selenium.By)
	"
	
	^ self findElementsBy: 'css selector' with: cssSelectorString! !

!BPWebElement methodsFor: 'misc' stamp: 'KrisGybels 4/18/2012 13:42'!
findElementsByClassName: nameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElements(org.openqa.selenium.By)
	"
	
	^ self findElementsBy: 'class name' with: nameString
! !

!BPWebElement methodsFor: 'misc' stamp: 'JohanBrichau 8/14/2012 19:57'!
findElementsByPartialLinkText: nameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElements(org.openqa.selenium.By)
	"
	
	^ self findElementsBy: 'partial link text' with: nameString
! !

!BPWebElement methodsFor: 'misc' stamp: 'KrisGybels 4/18/2012 11:10'!
findElementsByTagName: nameString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElements(org.openqa.selenium.By)
	"
	
	^ self findElementsBy: 'tag name' with: nameString
! !

!BPWebElement methodsFor: 'misc' stamp: 'KrisGybels 5/30/2012 16:04'!
findElementsByXPath: xpathString

	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#findElements(org.openqa.selenium.By)
	"
	
	^ self findElementsBy: 'xpath' with: xpathString
! !

!BPWebElement methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getAttribute: nameString
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#getAttribute(java.lang.String)
	"

	self
		flag: 'Check whether this implementation matches the description of the original Java method'.
	^driver
		httpGetHandleResponse: (self baseElementURL , 'attribute/') , nameString
		onSuccess: [:result | result at: 'value']! !

!BPWebElement methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getLocation
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#getLocation()
	"

	^driver httpGetHandleResponse: self baseElementURL , 'location'
		onSuccess: [:result | ((result at: 'value') at: 'x') @ ((result at: 'value') at: 'y')]! !

!BPWebElement methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getSize
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#getSize()
	"

	^driver httpGetHandleResponse: self baseElementURL , 'size'
		onSuccess: 
			[:result |
			((result at: 'value') at: 'width') @ ((result at: 'value') at: 'height')]! !

!BPWebElement methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getText
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#getText()
	"

	^driver httpGetHandleResponse: self baseElementURL , 'text'
		onSuccess: [:result | result at: 'value']! !

!BPWebElement methodsFor: 'comparing' stamp: 'KrisGybels 2/6/2014 14:56'!
hash

	"In #= we need to ask the remote driver to compare the elements, but we can't ask it for #hash since the wire protocol
		does not define an operation for that. We therefore resort to returning a constant hash:"
	
	^ 0! !

!BPWebElement methodsFor: 'initialize-release' stamp: 'haerle 8/19/2014 14:46'!
initWithDriver: initialDriver elementID: initialElementID

	self initialize.
	driver := initialDriver.
	elementID := initialElementID.! !

!BPWebElement methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
isDisplayed
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#isDisplayed()
	"

	^driver httpGetHandleResponse: self baseElementURL , 'displayed'
		onSuccess: [:result | result at: 'value']! !

!BPWebElement methodsFor: 'json' stamp: 'haerle 8/19/2014 14:46'!
jsonOn: stream
	"Pharo specific override to render the receiver."	

	(Dictionary new at: 'ELEMENT' put: elementID; yourself) jsonOn: stream! !

!BPWebElement methodsFor: 'json' stamp: 'haerle 8/19/2014 14:46'!
jsonWriteOn: stream
	"VisualWorks specific override for rendering the receiver. In case the JSONReader package is used instead of Javascript-Core from Seaside."

	((Dictionary new) at: 'ELEMENT' put: elementID; yourself) jsonWriteOn: stream! !

!BPWebElement methodsFor: 'events' stamp: 'haerle 8/19/2014 14:46'!
sendKeys: keyString
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebElement.html#sendKeys(java.lang.CharSequence...)
	"

	| keyArray |
	self
		flag: 'This may need to take something other than a string, to be able to send special key presses (like shift, command etc.)'.
	keyArray := keyString asArray collect: [:char | String with: char].
	driver
		httpPostHandleResponse: (self baseElementURL , 'value')
		jsonData: (Dictionary new
				at: 'value' put: keyArray;
				yourself)! !

BPObject subclass: #BPWindow
	instanceVariableNames: 'driver handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPWindow class methodsFor: 'instance creation' stamp: 'KrisGybels 11/6/2012 10:23'!
withDriver: driver handle: handle

	^ self basicNew initWithDriver: driver handle: handle! !

!BPWindow methodsFor: 'private' stamp: 'haerle 8/19/2014 14:46'!
baseURL

	^driver baseSessionURL , 'window/' , handle, '/'! !

!BPWindow methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getPosition
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.Window.html#getPosition()
	"

	^driver httpGetHandleResponse: self baseURL , 'position'
		onSuccess: 
			[:result |
			Point x: ((result at: 'value') at: 'x') y: ((result at: 'value') at: 'y')]! !

!BPWindow methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
getSize
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.Window.html#getSize()
	"

	^driver httpGetHandleResponse: self baseURL , 'size'
		onSuccess: 
			[:result |
			Point x: ((result at: 'value') at: 'width')
				y: ((result at: 'value') at: 'height')]! !

!BPWindow methodsFor: 'initialize-release' stamp: 'KrisGybels 11/6/2012 10:23'!
initWithDriver: initialDriver handle: initialHandle

	self initialize.
	driver := initialDriver.
	handle := initialHandle.
	! !

!BPWindow methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
setPosition: point
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.Window.html#setPosition(org.openqa.selenium.Point)
	"

	driver httpPostHandleResponse: (self baseURL , 'position')
		jsonData: (Dictionary new
				at: 'x' put: point x;
				at: 'y' put: point y;
				yourself)! !

!BPWindow methodsFor: 'misc' stamp: 'haerle 8/19/2014 14:46'!
setSize: point
	"
		http://selenium.googlecode.com/svn/trunk/docs/api/java/org/openqa/selenium/WebDriver.Window.html#setSize(org.openqa.selenium.Dimension)
	"

	driver httpPostHandleResponse: (self baseURL , 'size')
		jsonData: (Dictionary new
				at: 'width' put: point x;
				at: 'height' put: point y;
				yourself)! !

Object subclass: #BPValueHolder
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPValueHolder methodsFor: 'accessing' stamp: 'JohanBrichau 08/09/2014 00:33'!
value

   "Return the value of the instance variable 'value'."
   ^value
! !

!BPValueHolder methodsFor: 'updating' stamp: 'JohanBrichau 08/09/2014 00:33'!
value: newValue

   "Modify the value of the instance variable 'value'."
   value := newValue
! !

Error subclass: #BPException
	instanceVariableNames: 'errorCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPException commentStamp: 'haerle 8/19/2014 15:07' prior: 0!
Documentation from: https://code.google.com/p/selenium/wiki/JsonWireProtocol

Code 	Summary 	Detail
0 	Success 	The command executed successfully.
6 	NoSuchDriver 	A session is either terminated or not started
7 	NoSuchElement 	An element could not be located on the page using the given search parameters.
8 	NoSuchFrame 	A request to switch to a frame could not be satisfied because the frame could not be found.
9 	UnknownCommand 	The requested resource could not be found, or a request was received using an HTTP method that is not supported by the mapped resource.
10 	StaleElementReference 	An element command failed because the referenced element is no longer attached to the DOM.
11 	ElementNotVisible 	An element command could not be completed because the element is not visible on the page.
12 	InvalidElementState 	An element command could not be completed because the element is in an invalid state (e.g. attempting to click a disabled element).
13 	UnknownError 	An unknown server-side error occurred while processing the command.
15 	ElementIsNotSelectable 	An attempt was made to select an element that cannot be selected.
17 	JavaScriptError 	An error occurred while executing user supplied JavaScript.
19 	XPathLookupError 	An error occurred while searching for an element by XPath.
21 	Timeout 	An operation did not complete before its timeout expired.
23 	NoSuchWindow 	A request to switch to a different window could not be satisfied because the window could not be found.
24 	InvalidCookieDomain 	An illegal attempt was made to set a cookie under a different domain than the current page.
25 	UnableToSetCookie 	A request to set a cookie's value could not be satisfied.
26 	UnexpectedAlertOpen 	A modal dialog was open, blocking this operation
27 	NoAlertOpenError 	An attempt was made to operate on a modal dialog when one was not open.
28 	ScriptTimeout 	A script did not complete before its timeout expired.
29 	InvalidElementCoordinates 	The coordinates provided to an interactions operation are invalid.
30 	IMENotAvailable 	IME was not available.
31 	IMEEngineActivationFailed 	An IME engine could not be started.
32 	InvalidSelector 	Argument was an invalid selector (e.g. XPath/CSS).
33 	SessionNotCreatedException 	A new session could not be created.
34 	MoveTargetOutOfBounds 	Target provided for a move action is out of bounds. 
!

BPException subclass: #BPElementNotVisibleException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

!BPException methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
errorCode

	^errorCode! !

!BPException methodsFor: 'accessing' stamp: 'haerle 8/19/2014 14:46'!
errorCode: anObject

	errorCode := anObject! !

BPException subclass: #BPInvalidSelectorException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

BPException subclass: #BPNoSuchElementException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

BPException subclass: #BPStaleElementReferenceException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

BPException subclass: #BPUnknownServerException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!

BPException subclass: #BPUnsupportedCommandException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Core'!
BPPlatform initialize!
